Index: /palm/trunk/SOURCE/diffusion_u.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_u.f90	(revision 2231)
+++ /palm/trunk/SOURCE/diffusion_u.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography and surface concept
 ! 
 ! Former revisions:
@@ -95,6 +95,4 @@
  
 
-    USE wall_fluxes_mod
-
     PRIVATE
     PUBLIC diffusion_u
@@ -116,39 +114,43 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w,                  &
-                  drho_air, rho_air_zw
+           ONLY:  ddzu, ddzw, km, tend, u, v, w, drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
-           ONLY:  constant_top_momentumflux, topography, use_surface_fluxes,   &
+           ONLY:  constant_top_momentumflux, use_surface_fluxes,               &
                   use_top_fluxes
        
        USE grid_variables,                                                     &
-           ONLY:  ddx, ddx2, ddy, fym, fyp, wall_u
+           ONLY:  ddx, ddx2, ddy
        
        USE indices,                                                            &
-           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzb_diff_u, nzb_u_inner,      &
-                  nzb_u_outer, nzt, nzt_diff
-       
+           ONLY:  nxl, nxlu, nxr, nyn, nys, nzb, nzt, wall_flags_0
+     
        USE kinds
 
+       USE surface_mod,                                                        &
+           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, &
+                   surf_usm_v
+
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i     !< 
-       INTEGER(iwp) ::  j     !< 
-       INTEGER(iwp) ::  k     !< 
-       REAL(wp)     ::  kmym  !<
-       REAL(wp)     ::  kmyp  !<
-       REAL(wp)     ::  kmzm  !<
-       REAL(wp)     ::  kmzp  !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  usvs  !< 
-
-!
-!--    First calculate horizontal momentum flux u'v' at vertical walls,
-!--    if neccessary
-       IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes( usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, nzb_u_inner, &
-                            nzb_u_outer, wall_u )
-       ENDIF
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  l             !< running index of surface type, south- or north-facing wall
+       INTEGER(iwp) ::  m             !< running index surface elements
+       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
+
+       REAL(wp)     ::  flag          !< flag to mask topography grid points
+       REAL(wp)     ::  kmym          !< 
+       REAL(wp)     ::  kmyp          !<
+       REAL(wp)     ::  kmzm          !<
+       REAL(wp)     ::  kmzp          !<
+       REAL(wp)     ::  mask_bottom   !< flag to mask vertical upward-facing surface       
+       REAL(wp)     ::  mask_north    !< flag to mask vertical surface north of the grid point 
+       REAL(wp)     ::  mask_south    !< flag to mask vertical surface south of the grid point 
+       REAL(wp)     ::  mask_top      !< flag to mask vertical downward-facing surface 
+
+
 
        DO  i = nxlu, nxr
@@ -156,5 +158,12 @@
 !
 !--          Compute horizontal diffusion
-             DO  k = nzb_u_outer(j,i)+1, nzt
+             DO  k = nzb+1, nzt
+!
+!--             Predetermine flag to mask topography and wall-bounded grid points. 
+!--             It is sufficient to masked only north- and south-facing surfaces, which
+!--             need special treatment for the u-component. 
+                flag       = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i),   1 ) ) 
+                mask_south = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j-1,i), 1 ) )
+                mask_north = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j+1,i), 1 ) )
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
@@ -165,47 +174,75 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + 2.0_wp * (                                           &
-                      &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )    &
-                      &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )    &
-                      &            ) * ddx2                                    &
-                      & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy         &
-                      &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx         &
-                      &   - kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
-                      &   - kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx             &
-                      &   ) * ddy
+                        + 2.0_wp * (                                           &
+                                  km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )    &
+                                - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )    &
+                                   ) * ddx2 * flag                             &
+                        +          ( mask_north * (                            &
+                            kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy         &
+                          + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx         &
+                                                  )                            &
+                                   - mask_south * (                            &
+                            kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
+                          + kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx             &
+                                                  )                            &
+                                   ) * ddy  * flag                             
              ENDDO
-
-!
-!--          Wall functions at the north and south walls, respectively
-             IF ( wall_u(j,i) /= 0.0_wp )  THEN
-
-                DO  k = nzb_u_inner(j,i)+1, nzb_u_outer(j,i)
-                   kmyp = 0.25_wp *                                            &
-                          ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-                   kmym = 0.25_wp *                                            &
-                          ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
-
-                   tend(k,j,i) = tend(k,j,i)                                   &
-                                 + 2.0_wp * (                                  &
-                                       km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
-                                     - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
-                                            ) * ddx2                           &
-                                 + (   fyp(j,i) * (                            &
-                                  kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
-                                + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx   &
-                                                  )                            &
-                                     - fym(j,i) * (                            &
-                                  kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
-                                + kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
-                                                  )                            &
-                                     + wall_u(j,i) * usvs(k,j,i)               &
-                                   ) * ddy
-                ENDDO
-             ENDIF
-
-!
-!--          Compute vertical diffusion. In case of simulating a Prandtl layer,
-!--          index k starts at nzb_u_inner+2.
-             DO  k = nzb_diff_u(j,i), nzt_diff
+!
+!--          Add horizontal momentum flux u'v' at north- (l=0) and south-facing (l=1)
+!--          surfaces. Note, in the the flat case, loops won't be entered as 
+!--          start_index > end_index. Furtermore, note, no vertical natural surfaces
+!--          so far.           
+!--          Default-type surfaces
+             DO  l = 0, 1
+                surf_s = surf_def_v(l)%start_index(j,i)
+                surf_e = surf_def_v(l)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k           = surf_def_v(l)%k(m)
+                   tend(k,j,i) = tend(k,j,i) +                                 &                    
+                                    surf_def_v(l)%mom_flux_uv(m) * ddy
+                ENDDO   
+             ENDDO
+!
+!--          Natural-type surfaces
+             DO  l = 0, 1
+                surf_s = surf_lsm_v(l)%start_index(j,i)
+                surf_e = surf_lsm_v(l)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k           = surf_lsm_v(l)%k(m)
+                   tend(k,j,i) = tend(k,j,i) +                                 &                    
+                                    surf_lsm_v(l)%mom_flux_uv(m) * ddy
+                ENDDO   
+             ENDDO
+!
+!--          Urban-type surfaces
+             DO  l = 0, 1
+                surf_s = surf_usm_v(l)%start_index(j,i)
+                surf_e = surf_usm_v(l)%end_index(j,i)
+                DO  m = surf_s, surf_e
+                   k           = surf_usm_v(l)%k(m)
+                   tend(k,j,i) = tend(k,j,i) +                                 &                    
+                                    surf_usm_v(l)%mom_flux_uv(m) * ddy
+                ENDDO   
+             ENDDO
+
+!
+!--          Compute vertical diffusion. In case of simulating a surface layer,
+!--          respective grid diffusive fluxes are masked (flag 8) within this 
+!--          loop, and added further below, else, simple gradient approach is
+!--          applied. Model top is also mask if top-momentum flux is given. 
+             DO  k = nzb+1, nzt
+!
+!--             Determine flags to mask topography below and above. Flag 1 is 
+!--             used to mask topography in general, and flag 8 implies 
+!--             information about use_surface_fluxes. Flag 9 is used to control 
+!--             momentum flux at model top.  
+                mask_bottom = MERGE( 1.0_wp, 0.0_wp,                           &
+                                     BTEST( wall_flags_0(k-1,j,i), 8 ) ) 
+                mask_top    = MERGE( 1.0_wp, 0.0_wp,                           &
+                                     BTEST( wall_flags_0(k+1,j,i), 8 ) ) *     &
+                              MERGE( 1.0_wp, 0.0_wp,                           &
+                                     BTEST( wall_flags_0(k+1,j,i), 9 ) ) 
+                flag        = MERGE( 1.0_wp, 0.0_wp,                           &
+                                     BTEST( wall_flags_0(k,j,i), 1 ) ) 
 !
 !--             Interpolate eddy diffusivities on staggered gridpoints
@@ -216,11 +253,11 @@
 
                 tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            ) * rho_air_zw(k)                           &
-                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
-                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            ) * rho_air_zw(k-1)                         &
-                      &   ) * ddzw(k) * drho_air(k)
+                        + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
+                                   + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
+                                   ) * rho_air_zw(k)   * mask_top              &
+                          - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                                   + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                                   ) * rho_air_zw(k-1) * mask_bottom           &
+                          ) * ddzw(k) * drho_air(k) * flag
              ENDDO
 
@@ -236,34 +273,66 @@
 !--          because the vertical velocity is assumed to be zero at the surface.
              IF ( use_surface_fluxes )  THEN
-                k = nzb_u_inner(j,i)+1
-!
-!--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzp = 0.25_wp *                                               &
-                      ( km(k,j,i)+km(k+1,j,i)+km(k,j,i-1)+km(k+1,j,i-1) )
-
-                tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            ) * rho_air_zw(k)                           &
-                      &   - ( -usws(j,i) )                                     &
-                      &   ) * ddzw(k) * drho_air(k)
+!
+!--             Default-type surfaces, upward-facing
+                surf_s = surf_def_h(0)%start_index(j,i)
+                surf_e = surf_def_h(0)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_def_h(0)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                        + ( - ( - surf_def_h(0)%usws(m) )                      &
+                          ) * ddzw(k) * drho_air(k)
+                ENDDO
+!
+!--             Default-type surfaces, dowward-facing
+                surf_s = surf_def_h(1)%start_index(j,i)
+                surf_e = surf_def_h(1)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_def_h(1)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                        + ( - surf_def_h(1)%usws(m)                            &
+                          ) * ddzw(k) * drho_air(k)
+                ENDDO
+!
+!--             Natural-type surfaces, upward-facing
+                surf_s = surf_lsm_h%start_index(j,i)
+                surf_e = surf_lsm_h%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_lsm_h%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                        + ( - ( - surf_lsm_h%usws(m) )                         &
+                          ) * ddzw(k) * drho_air(k)
+                ENDDO
+!
+!--             Urban-type surfaces, upward-facing
+                surf_s = surf_usm_h%start_index(j,i)
+                surf_e = surf_usm_h%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_usm_h%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                       + ( - ( - surf_usm_h%usws(m) )                          &
+                         ) * ddzw(k) * drho_air(k)
+                ENDDO
+
              ENDIF
-
-!
-!--          Vertical diffusion at the first gridpoint below the top boundary,
-!--          if the momentum flux at the top is prescribed by the user
-             IF ( use_top_fluxes  .AND.  constant_top_momentumflux )  THEN
-                k = nzt
-!
-!--             Interpolate eddy diffusivities on staggered gridpoints
-                kmzm = 0.25_wp *                                               &
-                       ( km(k,j,i)+km(k-1,j,i)+km(k,j,i-1)+km(k-1,j,i-1) )
-
-                tend(k,j,i) = tend(k,j,i)                                      &
-                      & + ( ( -uswst(j,i) )                                    &
-                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
-                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            ) * rho_air_zw(k-1)                         &
-                      &   ) * ddzw(k) * drho_air(k)
+!
+!--          Add momentum flux at model top
+             IF ( use_top_fluxes )  THEN
+                surf_s = surf_def_h(2)%start_index(j,i)
+                surf_e = surf_def_h(2)%end_index(j,i)
+                DO  m = surf_s, surf_e
+
+                   k   = surf_def_h(2)%k(m)
+
+                   tend(k,j,i) = tend(k,j,i)                                   &
+                        + ( - surf_def_h(2)%usws(m) ) * ddzw(k) * drho_air(k)
+                ENDDO
              ENDIF
 
@@ -282,33 +351,51 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, km, tend, u, usws, uswst, v, w,                  &
-                  drho_air, rho_air_zw
+           ONLY:  ddzu, ddzw, km, tend, u, v, w, drho_air, rho_air_zw
        
        USE control_parameters,                                                 &
-           ONLY:  constant_top_momentumflux, use_surface_fluxes, use_top_fluxes
+           ONLY:  constant_top_momentumflux, use_surface_fluxes,               &
+                  use_top_fluxes
        
        USE grid_variables,                                                     &
-           ONLY:  ddx, ddx2, ddy, fym, fyp, wall_u
+           ONLY:  ddx, ddx2, ddy
        
        USE indices,                                                            &
-           ONLY:  nzb, nzb_diff_u, nzb_u_inner, nzb_u_outer, nzt, nzt_diff
-       
+           ONLY:  nzb, nzt, wall_flags_0
+      
        USE kinds
 
+       USE surface_mod,                                                        &
+           ONLY :  surf_def_h, surf_def_v, surf_lsm_h, surf_lsm_v, surf_usm_h, &
+                   surf_usm_v
+
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i     !< 
-       INTEGER(iwp) ::  j     !< 
-       INTEGER(iwp) ::  k     !< 
-       REAL(wp)     ::  kmym  !<
-       REAL(wp)     ::  kmyp  !<
-       REAL(wp)     ::  kmzm  !<
-       REAL(wp)     ::  kmzp  !<
-
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  usvs  !< 
-
-!
+       INTEGER(iwp) ::  i             !< running index x direction
+       INTEGER(iwp) ::  j             !< running index y direction
+       INTEGER(iwp) ::  k             !< running index z direction
+       INTEGER(iwp) ::  l             !< running index of surface type, south- or north-facing wall
+       INTEGER(iwp) ::  m             !< running index surface elements
+       INTEGER(iwp) ::  surf_e        !< End index of surface elements at (j,i)-gridpoint
+       INTEGER(iwp) ::  surf_s        !< Start index of surface elements at (j,i)-gridpoint
+
+       REAL(wp)     ::  flag          !< flag to mask topography grid points
+       REAL(wp)     ::  kmym          !< 
+       REAL(wp)     ::  kmyp          !<
+       REAL(wp)     ::  kmzm          !<
+       REAL(wp)     ::  kmzp          !<
+       REAL(wp)     ::  mask_bottom   !< flag to mask vertical upward-facing surface       
+       REAL(wp)     ::  mask_north    !< flag to mask vertical surface north of the grid point 
+       REAL(wp)     ::  mask_south    !< flag to mask vertical surface south of the grid point 
+       REAL(wp)     ::  mask_top      !< flag to mask vertical downward-facing surface 
+! 
 !--    Compute horizontal diffusion
-       DO  k = nzb_u_outer(j,i)+1, nzt
+       DO  k = nzb+1, nzt
+!
+!--       Predetermine flag to mask topography and wall-bounded grid points. 
+!--       It is sufficient to masked only north- and south-facing surfaces, which
+!--       need special treatment for the u-component. 
+          flag       = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i),   1 ) ) 
+          mask_south = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j-1,i), 1 ) )
+          mask_north = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j+1,i), 1 ) )
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
@@ -317,50 +404,71 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & + 2.0_wp * (                                           &
-                      &           km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )    &
-                      &         - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )    &
-                      &            ) * ddx2                                    &
-                      & + ( kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy         &
-                      &   + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx         &
-                      &   - kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy             &
-                      &   - kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx             &
-                      &   ) * ddy
+                       + 2.0_wp * (                                            &
+                                 km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i)   )     &
+                               - km(k,j,i-1) * ( u(k,j,i)   - u(k,j,i-1) )     &
+                                   ) * ddx2 * flag                             &
+                                 + (                                           &
+                  mask_north * kmyp * ( ( u(k,j+1,i) - u(k,j,i)     ) * ddy    &
+                                      + ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx    &
+                                      )                                        &
+                - mask_south * kmym * ( ( u(k,j,i)   - u(k,j-1,i)   ) * ddy    &
+                                      + ( v(k,j,i)   - v(k,j,i-1)   ) * ddx    &
+                                      )                                        &
+                                   ) * ddy  * flag
        ENDDO
 
 !
-!--    Wall functions at the north and south walls, respectively
-       IF ( wall_u(j,i) /= 0.0_wp )  THEN
-
-!
-!--       Calculate the horizontal momentum flux u'v'
-          CALL wall_fluxes( i, j, nzb_u_inner(j,i)+1, nzb_u_outer(j,i),        &
-                            usvs, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp )
-
-          DO  k = nzb_u_inner(j,i)+1, nzb_u_outer(j,i)
-             kmyp = 0.25_wp * ( km(k,j,i)+km(k,j+1,i)+km(k,j,i-1)+km(k,j+1,i-1) )
-             kmym = 0.25_wp * ( km(k,j,i)+km(k,j-1,i)+km(k,j,i-1)+km(k,j-1,i-1) )
-
-             tend(k,j,i) = tend(k,j,i)                                         &
-                                 + 2.0_wp * (                                  &
-                                       km(k,j,i)   * ( u(k,j,i+1) - u(k,j,i) ) &
-                                     - km(k,j,i-1) * ( u(k,j,i) - u(k,j,i-1) ) &
-                                            ) * ddx2                           &
-                                 + (   fyp(j,i) * (                            &
-                                  kmyp * ( u(k,j+1,i) - u(k,j,i)     ) * ddy   &
-                                + kmyp * ( v(k,j+1,i) - v(k,j+1,i-1) ) * ddx   &
-                                                  )                            &
-                                     - fym(j,i) * (                            &
-                                  kmym * ( u(k,j,i) - u(k,j-1,i) ) * ddy       &
-                                + kmym * ( v(k,j,i) - v(k,j,i-1) ) * ddx       &
-                                                  )                            &
-                                     + wall_u(j,i) * usvs(k)                   &
-                                   ) * ddy
-          ENDDO
-       ENDIF
-
-!
-!--    Compute vertical diffusion. In case of simulating a Prandtl layer,
-!--    index k starts at nzb_u_inner+2.
-       DO  k = nzb_diff_u(j,i), nzt_diff
+!--    Add horizontal momentum flux u'v' at north- (l=0) and south-facing (l=1)
+!--    surfaces. Note, in the the flat case, loops won't be entered as 
+!--    start_index > end_index. Furtermore, note, no vertical natural surfaces
+!--    so far.           
+!--    Default-type surfaces
+       DO  l = 0, 1
+          surf_s = surf_def_v(l)%start_index(j,i)
+          surf_e = surf_def_v(l)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k           = surf_def_v(l)%k(m)
+             tend(k,j,i) = tend(k,j,i) + surf_def_v(l)%mom_flux_uv(m) * ddy
+          ENDDO   
+       ENDDO
+!
+!--    Natural-type surfaces
+       DO  l = 0, 1
+          surf_s = surf_lsm_v(l)%start_index(j,i)
+          surf_e = surf_lsm_v(l)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k           = surf_lsm_v(l)%k(m)
+             tend(k,j,i) = tend(k,j,i) + surf_lsm_v(l)%mom_flux_uv(m) * ddy
+          ENDDO   
+       ENDDO
+!
+!--    Urban-type surfaces
+       DO  l = 0, 1
+          surf_s = surf_usm_v(l)%start_index(j,i)
+          surf_e = surf_usm_v(l)%end_index(j,i)
+          DO  m = surf_s, surf_e
+             k           = surf_usm_v(l)%k(m)
+             tend(k,j,i) = tend(k,j,i) + surf_usm_v(l)%mom_flux_uv(m) * ddy
+          ENDDO   
+       ENDDO
+!
+!--    Compute vertical diffusion. In case of simulating a surface layer,
+!--    respective grid diffusive fluxes are masked (flag 8) within this 
+!--    loop, and added further below, else, simple gradient approach is
+!--    applied. Model top is also mask if top-momentum flux is given.
+       DO  k = nzb+1, nzt
+!
+!--       Determine flags to mask topography below and above. Flag 1 is 
+!--       used to mask topography in general, and flag 8 implies 
+!--       information about use_surface_fluxes. Flag 9 is used to control 
+!--       momentum flux at model top. 
+          mask_bottom = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k-1,j,i), 8 ) ) 
+          mask_top    = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k+1,j,i), 8 ) ) *           &
+                        MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k+1,j,i), 9 ) )
+          flag        = MERGE( 1.0_wp, 0.0_wp,                                 &
+                               BTEST( wall_flags_0(k,j,i), 1 ) ) 
 !
 !--       Interpolate eddy diffusivities on staggered gridpoints
@@ -369,15 +477,15 @@
 
           tend(k,j,i) = tend(k,j,i)                                            &
-                      & + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
-                      &            + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
-                      &            ) * rho_air_zw(k)                           &
-                      &   - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
-                      &            + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
-                      &            ) * rho_air_zw(k-1)                         &
-                      &   ) * ddzw(k) * drho_air(k)
+                        + ( kmzp * ( ( u(k+1,j,i) - u(k,j,i)   ) * ddzu(k+1)   &
+                                   + ( w(k,j,i)   - w(k,j,i-1) ) * ddx         &
+                                   ) * rho_air_zw(k)   * mask_top              &
+                          - kmzm * ( ( u(k,j,i)   - u(k-1,j,i)   ) * ddzu(k)   &
+                                   + ( w(k-1,j,i) - w(k-1,j,i-1) ) * ddx       &
+                                   ) * rho_air_zw(k-1) * mask_bottom           &
+                          ) * ddzw(k) * drho_air(k) * flag
        ENDDO
 
 !
-!--    Vertical diffusion at the first grid point above the surface, if the
+!--    Vertical diffusion at the first surface grid points, if the
 !--    momentum flux at the bottom is given by the Prandtl law or if it is
 !--    prescribed by the user.
